-- equations for the block tag register
-- these should be considered part of the track equations: they don't have to be fast, just 
-- compact.

-- modified for max, high, and med bins

-- jamieson olsen <jamieson@fnal.gov>
-- 1 july 1999

library ieee;
use ieee.std_logic_1164.all;

entity btag16 is
 port (
	matrix_d: 		in std_logic_vector (351 downto 0);
	blktag_d: 		out std_logic_vector (15 downto 0)
    );
end btag16;


architecture blocktag_arch of btag16 is

	-- no signal definitions

 begin


	-- combinatorial stuff
	
	
	blktag_d(14) <= 	matrix_d(329) or 
						matrix_d(328) or 
						matrix_d(327) or 
						matrix_d(326) or 
						matrix_d(325) or 
						matrix_d(324) or 
						matrix_d(323) or 
						matrix_d(322) or 
						matrix_d(321) or 
						matrix_d(320) or 
						matrix_d(319) or 
						matrix_d(318) or 
						matrix_d(317) or 
						matrix_d(316) or 
						matrix_d(315) or 
						matrix_d(314) or 
						matrix_d(313) or 
						matrix_d(312) or 
						matrix_d(311) or 
						matrix_d(310) or 
						matrix_d(309) or 
						matrix_d(308);


	blktag_d(15) <=	matrix_d(351) or 
					matrix_d(350) or 
					matrix_d(349) or 
					matrix_d(348) or 
					matrix_d(347) or 
					matrix_d(346) or 
					matrix_d(345) or 
					matrix_d(344) or 
					matrix_d(343) or 
					matrix_d(342) or 
					matrix_d(341) or 
					matrix_d(340) or 
					matrix_d(339) or 
					matrix_d(338) or 
					matrix_d(337) or 
					matrix_d(336) or 
					matrix_d(335) or 
					matrix_d(334) or 
					matrix_d(333) or 
					matrix_d(332) or 
					matrix_d(331) or 
					matrix_d(330);

	blktag_d(12) <=	matrix_d(285) or 
					matrix_d(284) or 
					matrix_d(283) or 
					matrix_d(282) or 
					matrix_d(281) or 
					matrix_d(280) or 
					matrix_d(279) or 
					matrix_d(278) or 
					matrix_d(277) or 
					matrix_d(276) or 
					matrix_d(275) or 
					matrix_d(274) or 
					matrix_d(273) or 
					matrix_d(272) or 
					matrix_d(271) or 
					matrix_d(270) or 
					matrix_d(269) or 
					matrix_d(268) or 
					matrix_d(267) or 
					matrix_d(266) or 
					matrix_d(265) or 
					matrix_d(264);

	blktag_d(13) <=	matrix_d(307) or 
					matrix_d(306) or 
					matrix_d(305) or 
					matrix_d(304) or 
					matrix_d(303) or 
					matrix_d(302) or 
					matrix_d(301) or 
					matrix_d(300) or 
					matrix_d(299) or 
					matrix_d(298) or 
					matrix_d(297) or 
					matrix_d(296) or 
					matrix_d(295) or 
					matrix_d(294) or 
					matrix_d(293) or 
					matrix_d(292) or 
					matrix_d(291) or 
					matrix_d(290) or 
					matrix_d(289) or 
					matrix_d(288) or 
					matrix_d(287) or 
					matrix_d(286);

	blktag_d(10) <=	matrix_d(241) or 
					matrix_d(240) or 
					matrix_d(239) or 
					matrix_d(238) or 
					matrix_d(237) or 
					matrix_d(236) or 
					matrix_d(235) or 
					matrix_d(234) or 
					matrix_d(233) or 
					matrix_d(232) or 
					matrix_d(231) or 
					matrix_d(230) or 
					matrix_d(229) or 
					matrix_d(228) or 
					matrix_d(227) or 
					matrix_d(226) or 
					matrix_d(225) or 
					matrix_d(224) or 
					matrix_d(223) or 
					matrix_d(222) or 
					matrix_d(221) or 
					matrix_d(220);

	blktag_d(11) <= 	matrix_d(263) or 
						matrix_d(262) or 
						matrix_d(261) or 
						matrix_d(260) or 
						matrix_d(259) or 
						matrix_d(258) or 
						matrix_d(257) or 
						matrix_d(256) or 
						matrix_d(255) or 
						matrix_d(254) or 
						matrix_d(253) or 
						matrix_d(252) or 
						matrix_d(251) or 
						matrix_d(250) or 
						matrix_d(249) or 
						matrix_d(248) or 
						matrix_d(247) or 
						matrix_d(246) or 
						matrix_d(245) or 
						matrix_d(244) or 
						matrix_d(243) or 
						matrix_d(242);


	blktag_d(8) <=		matrix_d(197) or 
						matrix_d(196) or 
						matrix_d(195) or 
						matrix_d(194) or 
						matrix_d(193) or 
						matrix_d(192) or 
						matrix_d(191) or 
						matrix_d(190) or 
						matrix_d(189) or 
						matrix_d(188) or 
						matrix_d(187) or 
						matrix_d(186) or 
						matrix_d(185) or 
						matrix_d(184) or 
						matrix_d(183) or 
						matrix_d(182) or 
						matrix_d(181) or 
						matrix_d(180) or 
						matrix_d(179) or 
						matrix_d(178) or 
						matrix_d(177) or 
						matrix_d(176);

	blktag_d(9) <=		matrix_d(219) or 
						matrix_d(218) or 
						matrix_d(217) or 
						matrix_d(216) or 
						matrix_d(215) or 
						matrix_d(214) or 
						matrix_d(213) or 
						matrix_d(212) or 
						matrix_d(211) or 
						matrix_d(210) or 
						matrix_d(209) or 
						matrix_d(208) or 
						matrix_d(207) or 
						matrix_d(206) or 
						matrix_d(205) or 
						matrix_d(204) or 
						matrix_d(203) or 
						matrix_d(202) or 
						matrix_d(201) or 
						matrix_d(200) or 
						matrix_d(199) or 
						matrix_d(198);

	blktag_d(6) <=		matrix_d(153) or 
						matrix_d(152) or 
						matrix_d(151) or 
						matrix_d(150) or 
						matrix_d(149) or 
						matrix_d(148) or 
						matrix_d(147) or 
						matrix_d(146) or 
						matrix_d(145) or 
						matrix_d(144) or 
						matrix_d(143) or 
						matrix_d(142) or 
						matrix_d(141) or 
						matrix_d(140) or 
						matrix_d(139) or 
						matrix_d(138) or 
						matrix_d(137) or 
						matrix_d(136) or 
						matrix_d(135) or 
						matrix_d(134) or 
						matrix_d(133) or 
						matrix_d(132);

	blktag_d(7) <=		matrix_d(175) or 
						matrix_d(174) or 
						matrix_d(173) or 
						matrix_d(172) or 
						matrix_d(171) or 
						matrix_d(170) or 
						matrix_d(169) or 
						matrix_d(168) or 
						matrix_d(167) or 
						matrix_d(166) or 
						matrix_d(165) or 
						matrix_d(164) or 
						matrix_d(163) or 
						matrix_d(162) or 
						matrix_d(161) or 
						matrix_d(160) or 
						matrix_d(159) or 
						matrix_d(158) or 
						matrix_d(157) or 
						matrix_d(156) or 
						matrix_d(155) or 
						matrix_d(154);

	blktag_d(4) <= 	matrix_d(109) or 
					matrix_d(108) or 
					matrix_d(107) or 
					matrix_d(106) or 
					matrix_d(105) or 
					matrix_d(104) or 
					matrix_d(103) or 
					matrix_d(102) or 
					matrix_d(101) or 
					matrix_d(100) or 
					matrix_d(99) or 
					matrix_d(98) or 
					matrix_d(97) or 
					matrix_d(96) or 
					matrix_d(95) or 
					matrix_d(94) or 
					matrix_d(93) or 
					matrix_d(92) or 
					matrix_d(91) or 
					matrix_d(90) or 
					matrix_d(89) or 
					matrix_d(88);


	blktag_d(5) <=		matrix_d(131) or 
						matrix_d(130) or 
						matrix_d(129) or 
						matrix_d(128) or 
						matrix_d(127) or 
						matrix_d(126) or 
						matrix_d(125) or 
						matrix_d(124) or 
						matrix_d(123) or 
						matrix_d(122) or 
						matrix_d(121) or 
						matrix_d(120) or 
						matrix_d(119) or 
						matrix_d(118) or 
						matrix_d(117) or 
						matrix_d(116) or 
						matrix_d(115) or 
						matrix_d(114) or 
						matrix_d(113) or 
						matrix_d(112) or 
						matrix_d(111) or 
						matrix_d(110);

	blktag_d(2) <=		matrix_d(65) or 
						matrix_d(64) or 
						matrix_d(63) or 
						matrix_d(62) or 
						matrix_d(61) or 
						matrix_d(60) or 
						matrix_d(59) or 
						matrix_d(58) or 
						matrix_d(57) or 
						matrix_d(56) or 
						matrix_d(55) or 
						matrix_d(54) or 
						matrix_d(53) or 
						matrix_d(52) or 
						matrix_d(51) or 
						matrix_d(50) or 
						matrix_d(49) or 
						matrix_d(48) or 
						matrix_d(47) or 
						matrix_d(46) or 
						matrix_d(45) or 
						matrix_d(44);

	blktag_d(3) <=		matrix_d(87) or 
						matrix_d(86) or 
						matrix_d(85) or 
						matrix_d(84) or 
						matrix_d(83) or 
						matrix_d(82) or 
						matrix_d(81) or 
						matrix_d(80) or 
						matrix_d(79) or 
						matrix_d(78) or 
						matrix_d(77) or 
						matrix_d(76) or 
						matrix_d(75) or 
						matrix_d(74) or 
						matrix_d(73) or 
						matrix_d(72) or 
						matrix_d(71) or 
						matrix_d(70) or 
						matrix_d(69) or 
						matrix_d(68) or 
						matrix_d(67) or 
						matrix_d(66);

	blktag_d(0) <=		matrix_d(21) or 
						matrix_d(20) or 
						matrix_d(19) or 
						matrix_d(18) or 
						matrix_d(17) or 
						matrix_d(16) or 
						matrix_d(15) or 
						matrix_d(14) or 
						matrix_d(13) or 
						matrix_d(12) or 
						matrix_d(11) or 
						matrix_d(10) or 
						matrix_d(9) or 
						matrix_d(8) or 
						matrix_d(7) or 
						matrix_d(6) or 
						matrix_d(5) or 
						matrix_d(4) or 
						matrix_d(3) or 
						matrix_d(2) or 
						matrix_d(1) or 
						matrix_d(0);

	blktag_d(1) <= 	matrix_d(43) or 
					matrix_d(42) or 
					matrix_d(41) or 
					matrix_d(40) or 
					matrix_d(39) or 
					matrix_d(38) or 
					matrix_d(37) or 
					matrix_d(36) or 
					matrix_d(35) or 
					matrix_d(34) or 
					matrix_d(33) or 
					matrix_d(32) or 
					matrix_d(31) or 
					matrix_d(30) or 
					matrix_d(29) or 
					matrix_d(28) or 
					matrix_d(27) or 
					matrix_d(26) or 
					matrix_d(25) or 
					matrix_d(24) or 
					matrix_d(23) or 
					matrix_d(22);


end blocktag_arch;

