library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

-- counts the number of set bits in the 40 element array.
-- purely combinatorial, optimize for area!

entity sum40 is
    port (
        a:          in  std_logic_vector(39 downto 0);
        y:          out std_logic_vector( 5 downto 0)
    );
end sum40;

architecture sum40_arch of sum40 is

    -- define signals...

    signal count4a: std_logic_vector(2 downto 0);
    signal count4b: std_logic_vector(2 downto 0);
    signal count4c: std_logic_vector(2 downto 0);
    signal count4d: std_logic_vector(2 downto 0);
    signal count4e: std_logic_vector(2 downto 0);
    signal count4f: std_logic_vector(2 downto 0);
    signal count4g: std_logic_vector(2 downto 0);
    signal count4h: std_logic_vector(2 downto 0);
    signal count4i: std_logic_vector(2 downto 0);
    signal count4j: std_logic_vector(2 downto 0);

	signal sum4a:	std_logic_vector(3 downto 0);
	signal sum4b:	std_logic_vector(3 downto 0);
	signal sum4c:	std_logic_vector(3 downto 0);
	signal sum4d:	std_logic_vector(3 downto 0);
	signal sum4e:	std_logic_vector(3 downto 0);

	signal sum5a:	std_logic_vector(4 downto 0);
	signal sum5b:	std_logic_vector(4 downto 0);

	signal sum6a:	std_logic_vector(5 downto 0);

begin

	-- combinatorial stuff...

	count4a(2 downto 0)	<= 	"000" when (a(3 downto 0)="0000") else
							"001" when (a(3 downto 0)="0001") else
							"001" when (a(3 downto 0)="0010") else
							"001" when (a(3 downto 0)="0100") else
							"001" when (a(3 downto 0)="1000") else
							"011" when (a(3 downto 0)="0111") else
							"011" when (a(3 downto 0)="1110") else
							"011" when (a(3 downto 0)="1101") else
							"011" when (a(3 downto 0)="1011") else
							"100" when (a(3 downto 0)="1111") else
							"010";

	count4b(2 downto 0)	<= 	"000" when (a(7 downto 4)="0000") else
							"001" when (a(7 downto 4)="0001") else
							"001" when (a(7 downto 4)="0010") else
							"001" when (a(7 downto 4)="0100") else
							"001" when (a(7 downto 4)="1000") else
							"011" when (a(7 downto 4)="0111") else
							"011" when (a(7 downto 4)="1110") else
							"011" when (a(7 downto 4)="1101") else
							"011" when (a(7 downto 4)="1011") else
							"100" when (a(7 downto 4)="1111") else
							"010";

	count4c(2 downto 0)	<= 	"000" when (a(11 downto 8)="0000") else
							"001" when (a(11 downto 8)="0001") else
							"001" when (a(11 downto 8)="0010") else
							"001" when (a(11 downto 8)="0100") else
							"001" when (a(11 downto 8)="1000") else
							"011" when (a(11 downto 8)="0111") else
							"011" when (a(11 downto 8)="1110") else
							"011" when (a(11 downto 8)="1101") else
							"011" when (a(11 downto 8)="1011") else
							"100" when (a(11 downto 8)="1111") else
							"010";

	count4d(2 downto 0)	<= 	"000" when (a(15 downto 12)="0000") else
							"001" when (a(15 downto 12)="0001") else
							"001" when (a(15 downto 12)="0010") else
							"001" when (a(15 downto 12)="0100") else
							"001" when (a(15 downto 12)="1000") else
							"011" when (a(15 downto 12)="0111") else
							"011" when (a(15 downto 12)="1110") else
							"011" when (a(15 downto 12)="1101") else
							"011" when (a(15 downto 12)="1011") else
							"100" when (a(15 downto 12)="1111") else
							"010";

	count4e(2 downto 0)	<= 	"000" when (a(19 downto 16)="0000") else
							"001" when (a(19 downto 16)="0001") else
							"001" when (a(19 downto 16)="0010") else
							"001" when (a(19 downto 16)="0100") else
							"001" when (a(19 downto 16)="1000") else
							"011" when (a(19 downto 16)="0111") else
							"011" when (a(19 downto 16)="1110") else
							"011" when (a(19 downto 16)="1101") else
							"011" when (a(19 downto 16)="1011") else
							"100" when (a(19 downto 16)="1111") else
							"010";

	count4f(2 downto 0)	<= 	"000" when (a(23 downto 20)="0000") else
							"001" when (a(23 downto 20)="0001") else
							"001" when (a(23 downto 20)="0010") else
							"001" when (a(23 downto 20)="0100") else
							"001" when (a(23 downto 20)="1000") else
							"011" when (a(23 downto 20)="0111") else
							"011" when (a(23 downto 20)="1110") else
							"011" when (a(23 downto 20)="1101") else
							"011" when (a(23 downto 20)="1011") else
							"100" when (a(23 downto 20)="1111") else
							"010";

	count4g(2 downto 0)	<= 	"000" when (a(27 downto 24)="0000") else
							"001" when (a(27 downto 24)="0001") else
							"001" when (a(27 downto 24)="0010") else
							"001" when (a(27 downto 24)="0100") else
							"001" when (a(27 downto 24)="1000") else
							"011" when (a(27 downto 24)="0111") else
							"011" when (a(27 downto 24)="1110") else
							"011" when (a(27 downto 24)="1101") else
							"011" when (a(27 downto 24)="1011") else
							"100" when (a(27 downto 24)="1111") else
							"010";

	count4h(2 downto 0)	<= 	"000" when (a(31 downto 28)="0000") else
							"001" when (a(31 downto 28)="0001") else
							"001" when (a(31 downto 28)="0010") else
							"001" when (a(31 downto 28)="0100") else
							"001" when (a(31 downto 28)="1000") else
							"011" when (a(31 downto 28)="0111") else
							"011" when (a(31 downto 28)="1110") else
							"011" when (a(31 downto 28)="1101") else
							"011" when (a(31 downto 28)="1011") else
							"100" when (a(31 downto 28)="1111") else
							"010";

	count4i(2 downto 0)	<= 	"000" when (a(35 downto 32)="0000") else
							"001" when (a(35 downto 32)="0001") else
							"001" when (a(35 downto 32)="0010") else
							"001" when (a(35 downto 32)="0100") else
							"001" when (a(35 downto 32)="1000") else
							"011" when (a(35 downto 32)="0111") else
							"011" when (a(35 downto 32)="1110") else
							"011" when (a(35 downto 32)="1101") else
							"011" when (a(35 downto 32)="1011") else
							"100" when (a(35 downto 32)="1111") else
							"010";

	count4j(2 downto 0)	<= 	"000" when (a(39 downto 36)="0000") else
							"001" when (a(39 downto 36)="0001") else
							"001" when (a(39 downto 36)="0010") else
							"001" when (a(39 downto 36)="0100") else
							"001" when (a(39 downto 36)="1000") else
							"011" when (a(39 downto 36)="0111") else
							"011" when (a(39 downto 36)="1110") else
							"011" when (a(39 downto 36)="1101") else
							"011" when (a(39 downto 36)="1011") else
							"100" when (a(39 downto 36)="1111") else
							"010";

	sum4a(3 downto 0)	<= ('0'&count4a(2 downto 0)) + ('0'&count4b(2 downto 0));
	sum4b(3 downto 0)	<= ('0'&count4c(2 downto 0)) + ('0'&count4d(2 downto 0));
	sum4c(3 downto 0)	<= ('0'&count4e(2 downto 0)) + ('0'&count4f(2 downto 0));
	sum4d(3 downto 0)	<= ('0'&count4g(2 downto 0)) + ('0'&count4h(2 downto 0));
	sum4e(3 downto 0)	<= ('0'&count4i(2 downto 0)) + ('0'&count4j(2 downto 0));

	sum5a(4 downto 0)	<= ('0'&sum4a(3 downto 0)) + ('0'&sum4b(3 downto 0));
	sum5b(4 downto 0)	<= ('0'&sum4c(3 downto 0)) + ('0'&sum4d(3 downto 0));

	sum6a(5 downto 0)	<= ('0'&sum5a(4 downto 0)) + ('0'&sum5b(4 downto 0));

	y(5 downto 0)		<= sum6a(5 downto 0) + ("00"&sum4e(3 downto 0));

end sum40_arch;
